"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var path = __importStar(require("path"));
var chalk_1 = __importDefault(require("chalk"));
var command_line_application_1 = require("command-line-application");
var dedent_1 = __importDefault(require("dedent"));
var p = chalk_1.default.hex('#870048');
var y = chalk_1.default.hex('#F1A60E');
var r = chalk_1.default.hex('#C5000B');
var g = chalk_1.default.hex('#888888');
// prettier-ignore
var logo = ("\n      " + y('_________') + "\n     " + p('/') + y('\\       /') + r('\\') + "                   _______ _     _ _______  _____\n    " + p('/') + "  " + y('\\_____/') + "  " + r('\\') + "                  |_____| |     |    |    |     |\n   " + p('/   /') + "     " + r('\\   \\') + "                 |     | |_____|    |    |_____|\n  " + p('/___/') + " \\\u2594\u2594\\ " + r(' \\___\\') + "\n  " + g('\\   \\') + "  \\_/  " + g('/   /') + "     ______ _______        _______ _______ _______ _______\n   " + g('\\   \\') + "     " + g('/   /') + "     |_____/ |______ |      |______ |_____| |______ |______\n    " + g('\\   ▔▔▔▔▔   /') + "      |    \\_ |______ |_____ |______ |     | ______| |______\n     " + g('\\         /') + "\n      " + g('▔▔▔▔▔▔▔▔▔ ') + "\n").replace(/\\/g, '\\\\');
var version = {
    name: 'version',
    alias: 'V',
    type: Boolean,
    description: "Display auto's version",
    group: 'global'
};
var defaultOptions = [
    {
        name: 'verbose',
        alias: 'v',
        type: Boolean,
        description: 'Show some more logs',
        group: 'global'
    },
    {
        name: 'very-verbose',
        alias: 'w',
        type: Boolean,
        description: 'Show a lot more logs',
        group: 'global'
    },
    {
        name: 'repo',
        type: String,
        description: 'The repo to set the status on. Defaults to looking in the package definition for the platform',
        group: 'global'
    },
    {
        name: 'owner',
        type: String,
        description: 'The owner of the GitHub repo. Defaults to reading from the package definition for the platform',
        group: 'global'
    },
    {
        name: 'github-api',
        type: String,
        description: 'GitHub API to use',
        group: 'global'
    },
    {
        name: 'plugins',
        type: String,
        multiple: true,
        description: 'Plugins to load auto with. (defaults to just npm)',
        group: 'global'
    }
];
var baseBranch = {
    name: 'base-branch',
    type: String,
    description: 'Branch to treat as the "master" branch',
    group: 'global'
};
var pr = {
    name: 'pr',
    type: Number,
    description: 'The pull request the command should use. Detects PR number in CI',
    group: 'main'
};
var dryRun = {
    name: 'dry-run',
    alias: 'd',
    type: Boolean,
    description: 'Report what command will do but do not actually do anything',
    group: 'main'
};
var url = {
    name: 'url',
    type: String,
    description: 'URL to associate with this status',
    group: 'main'
};
var noVersionPrefix = {
    name: 'no-version-prefix',
    type: Boolean,
    description: "Use the version as the tag without the 'v' prefix",
    group: 'main'
};
var name = {
    name: 'name',
    type: String,
    description: 'Git name to commit and release with. Defaults to package definition for the platform',
    group: 'main'
};
var email = {
    name: 'email',
    type: String,
    description: 'Git email to commit with. Defaults to package definition for the platform',
    group: 'main'
};
var context = {
    name: 'context',
    type: String,
    description: 'A string label to differentiate this status from others',
    group: 'main'
};
var message = {
    name: 'message',
    group: 'main',
    type: String,
    alias: 'm'
};
var skipReleaseLabels = {
    name: 'skip-release-labels',
    type: String,
    group: 'main',
    multiple: true,
    description: "Labels that will not create a release. Defaults to just 'skip-release'"
};
var deleteFlag = {
    name: 'delete',
    type: Boolean,
    group: 'main'
};
exports.commands = [
    {
        name: 'init',
        group: 'Setup Command',
        description: 'Interactive setup for most configurable options',
        examples: ['{green $} auto init'],
        options: [
            {
                name: 'only-labels',
                type: Boolean,
                group: 'main',
                description: 'Only run init for the labels. As most other options are for advanced users'
            },
            dryRun
        ]
    },
    {
        name: 'create-labels',
        group: 'Setup Command',
        description: "Create your project's labels on github. If labels exist it will update them.",
        examples: ['{green $} auto create-labels'],
        options: [dryRun]
    },
    {
        name: 'label',
        group: 'Pull Request Interaction Commands',
        description: "Get the labels for a pull request. Doesn't do much, but the return value lets you write you own scripts based off of the PR labels!",
        options: [
            __assign(__assign({}, pr), { description: pr.description + " (defaults to last merged PR)" })
        ],
        examples: ['{green $} auto label --pr 123']
    },
    {
        name: 'comment',
        group: 'Pull Request Interaction Commands',
        description: 'Comment on a pull request with a markdown message. Each comment has a context, and each context only has one comment.',
        require: [['message', 'delete']],
        options: [
            pr,
            context,
            {
                name: 'edit',
                type: Boolean,
                alias: 'e',
                group: 'main',
                description: 'Edit old comment'
            },
            __assign(__assign({}, deleteFlag), { description: 'Delete old comment' }),
            __assign(__assign({}, message), { description: 'Message to post to comment' }),
            dryRun
        ],
        examples: [
            '{green $} auto comment --delete',
            '{green $} auto comment --pr 123 --message "# Why you\'re wrong..."',
            '{green $} auto comment --pr 123 --edit --message "This smells..." --context code-smell'
        ]
    },
    {
        name: 'pr-check',
        group: 'Pull Request Interaction Commands',
        description: 'Check that a pull request has a SemVer label',
        require: ['url'],
        options: [
            pr,
            url,
            dryRun,
            __assign(__assign({}, context), { defaultValue: 'ci/pr-check' }),
            skipReleaseLabels
        ],
        examples: ['{green $} auto pr-check --url http://your-ci.com/build/123']
    },
    {
        name: 'pr-status',
        group: 'Pull Request Interaction Commands',
        description: 'Set the status on a PR commit',
        require: ['state', 'url', 'description', 'context'],
        options: [
            {
                name: 'sha',
                type: String,
                group: 'main',
                description: 'Specify a custom git sha. Defaults to the HEAD for a git repo in the current repository'
            },
            __assign(__assign({}, pr), { description: 'PR to set the status on. Detects PR number in CI' }),
            url,
            {
                name: 'state',
                type: String,
                group: 'main',
                description: "State of the PR. ['pending', 'success', 'error', 'failure']"
            },
            {
                name: 'description',
                type: String,
                group: 'main',
                description: 'A description of the status'
            },
            {
                name: 'context',
                type: String,
                group: 'main',
                description: 'A string label to differentiate this status from others'
            },
            dryRun
        ],
        examples: [
            "{green $} auto pr \\\\ \n   --state pending \\\\ \n   --description \"Build still running...\" \\\\ \n   --context build-check"
        ]
    },
    {
        name: 'pr-body',
        group: 'Pull Request Interaction Commands',
        description: 'Update the body of a PR with a message. Appends to PR and will not overwrite user content. Each comment has a context, and each context only has one comment.',
        require: [['message', 'delete']],
        options: [
            pr,
            context,
            __assign(__assign({}, deleteFlag), { description: 'Delete old PR body update' }),
            __assign(__assign({}, message), { description: 'Message to post to PR body' }),
            dryRun
        ],
        examples: [
            '{green $} auto pr-body --delete',
            '{green $} auto pr-body --pr 123 --comment "The new version is: 1.2.3"'
        ]
    },
    {
        name: 'version',
        group: 'Release Commands',
        description: 'Get the semantic version bump for the given changes. Requires all PRs to have labels for the change type. If a PR does not have a label associated with it, it will default to `patch`.',
        options: [
            {
                name: 'only-publish-with-release-label',
                type: Boolean,
                description: "Only bump version if 'release' label is on pull request",
                group: 'main'
            },
            skipReleaseLabels,
            {
                name: 'from',
                type: String,
                group: 'main',
                description: 'Git revision (tag, commit sha, ...) to calculate version bump from. Defaults to latest github release'
            }
        ],
        examples: [
            {
                desc: 'Get the new version using the last release to head',
                example: '{green $} auto version'
            },
            {
                desc: 'Skip releases with multiple labels',
                example: '{green $} auto version --skip-release-labels documentation CI'
            }
        ]
    },
    {
        name: 'changelog',
        group: 'Release Commands',
        description: "Prepend release notes to `CHANGELOG.md`, create one if it doesn't exist, and commit the changes.",
        options: [
            dryRun,
            noVersionPrefix,
            name,
            email,
            {
                name: 'from',
                type: String,
                group: 'main',
                description: 'Tag to start changelog generation on. Defaults to latest tag.'
            },
            {
                name: 'to',
                type: String,
                group: 'main',
                description: 'Tag to end changelog generation on. Defaults to HEAD.'
            },
            __assign(__assign({}, message), { description: "Message to commit the changelog with. Defaults to 'Update CHANGELOG.md [skip ci]'" }),
            baseBranch
        ],
        examples: [
            {
                desc: 'Generate a changelog from the last release to head',
                example: '{green $} auto changelog'
            },
            {
                desc: 'Generate a changelog across specific versions',
                example: '{green $} auto changelog --from v0.20.1 --to v0.21.0'
            }
        ]
    },
    {
        name: 'release',
        group: 'Release Commands',
        description: 'Auto-generate a github release',
        options: [
            dryRun,
            noVersionPrefix,
            name,
            email,
            {
                name: 'from',
                type: String,
                group: 'main',
                description: 'Git revision (tag, commit sha, ...) to start release notes from. Defaults to latest tag.'
            },
            {
                name: 'use-version',
                type: String,
                group: 'main',
                description: 'Version number to publish as. Defaults to reading from the package definition for the platform.'
            },
            baseBranch
        ],
        examples: [
            '{green $} auto release',
            '{green $} auto release --from v0.20.1 --use-version v0.21.0'
        ]
    },
    {
        name: 'shipit',
        group: 'Release Commands',
        description: dedent_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n      Run the full `auto` release pipeline. Detects if in a lerna project.\n\n      1. call from base branch -> latest version released\n      2. call from PR in CI -> canary version released\n      3. call locally when not on base branch -> canary version released\n    "], ["\n      Run the full \\`auto\\` release pipeline. Detects if in a lerna project.\n\n      1. call from base branch -> latest version released\n      2. call from PR in CI -> canary version released\n      3. call locally when not on base branch -> canary version released\n    "]))),
        examples: ['{green $} auto shipit'],
        options: [baseBranch, dryRun]
    },
    {
        name: 'canary',
        group: 'Release Commands',
        description: dedent_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      Make a canary release of the project. Useful on PRs. If ran locally, `canary` will release a canary version for your current git HEAD.\n\n      1. In PR: 1.2.3-canary.123.0 + add version to PR body\n      2. Locally: 1.2.3-canary.1810cfd\n    "], ["\n      Make a canary release of the project. Useful on PRs. If ran locally, \\`canary\\` will release a canary version for your current git HEAD.\n\n      1. In PR: 1.2.3-canary.123.0 + add version to PR body\n      2. Locally: 1.2.3-canary.1810cfd\n    "]))),
        examples: [
            '{green $} auto canary',
            '{green $} auto canary --pr 123 --build 5',
            '{green $} auto canary --message "Install PR version: `yarn add -D my-project@%v`"',
            '{green $} auto canary --message false'
        ],
        options: [
            dryRun,
            __assign(__assign({}, pr), { description: 'PR number to use to create the canary version. Detected in CI env' }),
            {
                name: 'build',
                type: String,
                group: 'main',
                description: 'Build number to use to create the canary version. Detected in CI env'
            },
            __assign(__assign({}, message), { description: "Message to comment on PR with. Defaults to 'Published PR with canary version: %v'. Pass false to disable the comment" })
        ]
    }
];
function printVersion() {
    var packagePath = path.join(__dirname, '../package.json');
    var packageJson = JSON.parse(fs.readFileSync(packagePath, 'utf8'));
    console.log("v" + packageJson.version);
}
function parseArgs(testArgs) {
    var mainOptions = command_line_application_1.app({
        name: 'auto',
        logo: logo,
        description: 'Generate releases based on semantic version labels on pull requests, and other pull request automation tools.',
        commands: exports.commands,
        options: __spread([version], defaultOptions)
    }, {
        argv: testArgs
    });
    if (!mainOptions) {
        return [];
    }
    if (!mainOptions._command) {
        if (mainOptions.version) {
            printVersion();
        }
        return [];
    }
    return [mainOptions._command, mainOptions];
}
exports.default = parseArgs;
var templateObject_1, templateObject_2;
//# sourceMappingURL=parse-args.js.map